﻿using System;
using System.ComponentModel;

namespace XDG
{
    public class Employee:INotifyPropertyChanged
    {
        private int employeeID;
        private string name;
        private bool onSite;
        private DateTime dateOfHire;
        private int department;
        private string site;
        private double salary;

        public double Salary
        {
            get { return salary; }
            set
            {
                this.salary = value;
                NotifyPropertyChanged("Salary");
            }
        }

        public int EmployeeID 
        { 
            get { return this.employeeID; } 
            set 
            { 
                this.employeeID = value;
                NotifyPropertyChanged("EmployeeID");
            } 
        }

        public string Name 
        { 
            get { return this.name; } 
            set 
            { 
                this.name = value;
                NotifyPropertyChanged("Name");
            } 
        }

        public bool OnSite 
        { 
            get { return this.onSite; } 
            set 
            { 
                this.onSite = value;
                NotifyPropertyChanged("OnSite");
            } 
        }

        public DateTime DateOfHire 
        { 
            get { return this.dateOfHire; } 
            set 
            {
                this.dateOfHire = value;
                NotifyPropertyChanged("DateOfHire");
            } 
        }

        public int Department 
        { 
            get { return this.department; } 
            set 
            { 
                this.department = value;
                NotifyPropertyChanged("Department");
            } 
        }
        public string Site 
        { 
            get { return this.site; } 
            set 
            { 
                this.site = value;
                NotifyPropertyChanged("Site");
            } 
        }
        

        public Employee()
        {
            this.employeeID = int.MinValue;
            this.name = string.Empty;
            this.onSite = false;
            this.dateOfHire = DateTime.MinValue;
            this.department = int.MinValue;
            this.site = String.Empty;
            this.salary = 0;
        }
        public Employee(int employeeID, string name, bool onSite, DateTime dateOfHire, int department, string site, double salary)
        {
            this.employeeID = employeeID;
            this.name = name;
            this.onSite = onSite;
            this.dateOfHire = dateOfHire;
            this.department = department;
            this.site = site;
            this.salary = salary;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion
    }
}
